"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class FamilySelection(ProtocolElement):
    """
    FamilySelection =================================== A collection of
    selection events and global results for family selection
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "events",
        "flagged",
        "rvsgAnnotation",
        "status",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_3 import metrics as metrics_1_2_1

        return {
            "events": metrics_1_2_1.SelectionEvent,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_3 import metrics as metrics_1_2_1

        return {
            "status": metrics_1_2_1.SelectionStatus,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_3 import metrics as metrics_1_2_1

        return {
            "org.gel.models.metrics.avro.SelectionEvent": metrics_1_2_1.SelectionEvent,
            "org.gel.models.metrics.avro.SelectionStatus": metrics_1_2_1.SelectionStatus,
            "org.gel.models.metrics.avro.FamilySelection": metrics_1_2_1.FamilySelection,
        }

    __slots__ = [
        "events",
        "flagged",
        "rvsgAnnotation",
        "status",
    ]

    def __init__(
        self,
        events,
        flagged,
        rvsgAnnotation,
        status,
        validate=None,
        **kwargs
    ):
        """Initialise the metrics_1_2_1.FamilySelection model.

        :param events:
            List of SelectionEvents, one for each test performed
        :type events: list[SelectionEvent]
        :param flagged:
            True if any flags are raised in the selection events
        :type flagged: boolean
        :param rvsgAnnotation:
            Name of ReportedVsGenetic annotation set that this data is based on
        :type rvsgAnnotation: str
        :param status:
            Overall family selection status
        :type status: SelectionStatus
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.2.1"
